#!/usr/bin/env python2
# by baochan120, 2016
# Copy input file to output file, randomly corrupting bits

import sys
import random

if len(sys.argv) != 4:
    print "Usage: corruptbits.py percent inputfile outputfile"
    print "   where e.g. percent = 0.05 makes 5% chance any copied bit's value will be flipped"
    print "   (percent=.5 will produce completely random output same size as input, percent=1 will flip all bits)"
    sys.exit()

percent = float(sys.argv[1])
infile_name = str(sys.argv[2])
outfile_name = str(sys.argv[3])

with open(infile_name, 'r') as infile:
    with open(outfile_name, 'w') as outfile:
        byte = infile.read(1)
        while byte:
            for bit in range(1,8):
                if random.random() < percent:
                    # ^ = Bitwise XOR
                    byte = chr(ord(byte) ^ int(2 ** bit))
            outfile.write(byte)
            byte = infile.read(1)


